'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tasks = undefined;

var _listr = require('listr');

var _listr2 = _interopRequireDefault(_listr);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _pkgDir = require('pkg-dir');

var _pkgDir2 = _interopRequireDefault(_pkgDir);

var _getDeps = require('./get-deps');

var _getDeps2 = _interopRequireDefault(_getDeps);

var _filter = require('./filter');

var _exec = require('./exec');

var _exec2 = _interopRequireDefault(_exec);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const tasks = exports.tasks = _co2.default.wrap(function* (input, flags) {
  const tasks = new _listr2.default([{
    title: 'Anylise the dependent pkgs',
    task: () => Promise.resolve('done')
  }, {
    title: 'Filter the pkgs',
    skip: ctx => ctx.deps.length === 0,
    task: ctx => {
      ctx.deps = ctx.deps.filter(pkg => (0, _filter.filterNodeCorePkgs)(pkg));
      if (!ctx.opts.here || (0, _utils.hasPkgJsonHere)()) {
        ctx.deps = ctx.deps.filter(pkg => (0, _filter.filterDepsExisted)(pkg));
      }
    }
  }, {
    title: 'Install pkgs via yarn',
    skip: ctx => {
      if (ctx.deps.length === 0) {
        return 'deps already exists';
      }
    },
    task: ctx => (0, _exec2.default)('yarn', ['add'].concat(ctx.deps, ctx.opts.yarn))
  }]);

  const opts = {
    yarn: [],
    here: ''
  };
  const deps = yield (0, _getDeps2.default)(input, flags);
  const projectRootPath = yield (0, _pkgDir2.default)();

  if (flags.d) {
    opts.yarn.push('--dev');
  }
  if (flags.h) {
    opts.here = true;
  } else {
    process.chdir(projectRootPath);
  }

  return tasks.run({ deps, opts });
});